#!/usr/bin/python

# The prupose of this script is to mangle URLs found in css files to support
# the private/internal proxy of device http traffic
#
# 12/21/06 rmerrill
#

from mod_python import apache
import re

# This is the method that apache looks for
# when calling the output filter through
# mod_python
def outputfilter(filter):
    request = filter.req
    content_type = request.content_type
#    request.log_error(content_type + ' - 1')
    in_headers = request.headers_in.items()
    out_headers = request.headers_out.items()
#    for (header,val) in in_headers:
#        request.log_error(header + ' = ' + val)

    # grab the private device ip
    private_ip = ''
    is_private_ip = False
    tokens = request.uri.split('/')
    for token in tokens:
#        request.log_error('token = ' + token)
        if is_private_ip:
            private_ip = token
            is_private_ip = False

        if 'privateproxy' == token:
            is_private_ip = True
#    request.log_error('private_ip = ' + private_ip)
    
    # update headers with redirected URL
    server_ip = request.headers_in.get('HOST')
#    request.log_error('server_ip = ' + server_ip)

    if '' != server_ip and None != server_ip:
        new_loc = ''
        out_location = request.headers_out.get('Location')
        if '' != out_location and None != out_location:
            request.log_error('Old Location = ' + out_location)
            http_start = re.compile('^http://')
            https_start = re.compile('^https://')
            slash_start = re.compile('^/')
            proxy_path = re.compile('.*privateproxy.*')
            if not proxy_path.match(out_location):
                if http_start.match(out_location):
                    tokens = out_location.split('/')
                    token_len = len(tokens)
                    url_path = ''
                    if token_len >=4:
                        #url_path = tokens[3]
                        for i in range(3,token_len-1):
                            url_path = url_path + tokens[i] + '/'
                        url_path = url_path + tokens[token_len-1]
                        new_loc = 'http://' + server_ip + '/privateproxy/' + private_ip + '/' + url_path
                        request.headers_out['Location'] = new_loc
                elif https_start.match(out_location):
                    tokens = out_location.split('/')
                    token_len = len(tokens)
                    url_path = ''
                    if token_len >=4:
                        #url_path = tokens[3]
                        for i in range(3,token_len-1):
                            url_path = url_path + tokens[i] + '/'
                        url_path = url_path + tokens[token_len-1]
                        new_loc = 'https://' + server_ip + '/privateproxy/' + private_ip + '/' + url_path
                        request.headers_out['Location'] = new_loc
                elif slash_start.match(out_location):
                    if request.subprocess_env.has_key('HTTPS') and request.subprocess_env['HTTPS'] == 'on':
                        new_loc = 'https://' + server_ip + '/privateproxy/' + private_ip + out_location
                    else:
                        new_loc = 'http://' + server_ip + '/privateproxy/' + private_ip + out_location
                    request.headers_out['Location'] = new_loc
            request.log_error('New Location = ' + new_loc)
    

    # check content_type for data to filter
    # and create filter replacement data
#    request.log_error(content_type)
    replacements = buildReplacementData(content_type, private_ip)
    filter_flag = False
    if len(replacements) > 0:
        filter_flag = True

    # do filtering
    if filter_flag:
        filterData(replacements, filter)
    else:
        # do nothing
        filter.pass_on()

# This function builds the replacement string list
# based on the content type received
def buildReplacementData(content_type, private_ip):
    replacements = ()
    text_html = re.compile('text/html.*')
    text_css = re.compile('text/css.*')
    if None != content_type:
        if text_html.match(content_type):
            replacements = (
                (re.compile('"/'), '"/privateproxy/' + private_ip + '/'),
                (re.compile("'/"), "'/privateproxy/" + private_ip + "/"),
                (re.compile('(src|SRC)="\.\./'), 'SRC="'),
                (re.compile("(src|SRC)='\.\./"), "SRC='"),
                (re.compile('(href|HREF)="\.\./'), 'HREF="'),
                (re.compile("(href|HREF)='\.\./"), "HREF='"),
            )
        elif text_css.match(content_type):
            replacements = (
                (re.compile('url\(/'), 'url(/privateproxy/' + private_ip + '/'),
            )
    return replacements

# This function does all the text filtering in the
# html and css files that pass through the filter
def filterData(replacements, filter):
    # update urls for proxying

    if not hasattr(filter.req,'temp_doc'): # the start
        filter.req.temp_doc = [] # create new attribute to hold document

    # If content-length ended up wrong, Gecko browsers truncated data, so
    if "Content-Length" in filter.req.headers_out:
        del filter.req.headers_out["Content-Length"]

    temp_doc = filter.req.temp_doc

    s = filter.read()
    while s: # could get '' at any point, but only get None at end
        temp_doc.append(s)
        s = filter.read()

    if s is None: # the end
        temp_doc = ''.join(temp_doc)
        for (regex,new) in replacements:
            temp_doc = regex.sub(new,temp_doc)
        #filter.req.set_content_length(len(temp_doc)) # this didn't seem to work
        filter.write(temp_doc)
        filter.close()

